//////////////////////////////////////////////////////////////////////////////
// BDASH.H                                                                  //
//////////////////////////////////////////////////////////////////////////////

#ifndef _BDASH_H
#define _BDASH_H

typedef unsigned char UCHAR;

// functions
void main();
void Explode(int x, int y); 		// explode with diamonds
void ScanMap();                		// scan & update map
int EnemyMove(UCHAR *fm, UCHAR *tm, int dir, long idir); // move an enemy
void ScrollMap();					// scroll background
int CanMove(char a, char b);		// check if tile is blocking
int MovePlayer();             		// player input & movement
void InitGraph();              		// initialize graphics
void main();

// tile types
#define EMPTY 0
#define NORMAL 1
#define DIAMOND 2
#define STONE 3
#define SOLID 4
#define BRICK 5
#define EXIT 6
#define PLAYER 7
#define PLAYERD 8 // 8-11
#define ENEMY1 16 // 16-23
#define ENEMY2 24 // 24-31

// tile modifiers
#define UP 0
#define RIGHT 1
#define DOWN 2
#define LEFT 3

#define SCAN 4

// GBC palette definitions
#define CGBPAL(id,pal) id##CGBPal##pal##c0,id##CGBPal##pal##c1,id##CGBPal##pal##c2,id##CGBPal##pal##c3
#define CGBPALS(id) {CGBPAL(id,0),CGBPAL(id,1),CGBPAL(id,2),CGBPAL(id,3),CGBPAL(id,4),CGBPAL(id,5),CGBPAL(id,6),CGBPAL(id,7)}

#endif

//////////////////////////////////////////////////////////////////////////////
