//////////////////////////////////////////////////////////////////////////////
// BDASH.C                                                                  //
//   written by Dark Fader                                                  //
//   copyright (c) BlackThunder 1999                                        //
//////////////////////////////////////////////////////////////////////////////
#include <gb\gb.h>
#include <string.h>
#include "bdash.h"
//#include "sound.h"
#include "tiles.h"
#include "map.h"
#include "title.h"
#include "titlemap.h"
#include "rumble.h"

UWORD paltitle[] = CGBPALS(title);
UWORD palettes[] = CGBPALS(tiles);
UCHAR fastmap[32][32];
UCHAR (*tilemap)[32][32] = (void*)0x9800; // use set_data!
UCHAR empty = EMPTY;
int px,py;		// player position
int danger;		// player should walk away?
int alive;		// player is alive?
int diamonds;	// diamonds left
int scan;		// odd/even frame

//////////////////////////////////////////////////////////////////////////////
// PUT                                                                      //
//////////////////////////////////////////////////////////////////////////////
// put tile
#define PUT(fm,tm,what) \
{ \
	UCHAR temp = what; \
	VBK_REG = 1; set_data(tm, &tilesCGB[what], 1); \
	VBK_REG = 0; set_data(tm, &temp, 1); \
	fm = what; \
}

//////////////////////////////////////////////////////////////////////////////
// MOVE                                                                     //
//////////////////////////////////////////////////////////////////////////////
// move tile
#define MOVE(fm,tm,fm2,tm2) \
{ \
	VBK_REG = 1;set_data(tm2, &tilesCGB[*fm], 1); \
				set_data(tm, &tilesCGB[EMPTY], 1); \
	VBK_REG = 0;set_data(tm2, fm, 1); \
				set_data(tm, &empty, 1); \
	*fm2 = *fm; *fm = EMPTY; \
}

//////////////////////////////////////////////////////////////////////////////
// Explode                                                                  //
//////////////////////////////////////////////////////////////////////////////
void Explode(int x, int y) // diamond explosion
{
	int xx,yy;
	//SndExplosion();
	for (yy=y-1; yy<=y+1; yy++)
	{
		for (xx=x-1; xx<=x+1; xx++)
		{
			switch (fastmap[yy][xx])
			{
				case SOLID:
					break;
				case PLAYER:
					alive=0;
				default:
					PUT(fastmap[yy][xx], &(*tilemap)[yy][xx], DIAMOND);
					break;
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
// ScanMap                                                                  //
//////////////////////////////////////////////////////////////////////////////
void ScanMap() // scan & update map
{
	int x,y;
	int sndfall=0;
	UCHAR *fm = (void*)((long)fastmap + (long)1023); // fast tilemap
	UCHAR *tm = (void*)((long)tilemap + (long)1023); // real tilemap

	for (y=31; y>=0; y--) for (x=31; x>=0; x--, fm--, tm--)
	{
		switch (*fm)
		{
			case STONE:
			case DIAMOND:
			{
				switch (*(fm+32))
				{ // what's down there?
					case EMPTY:
						MOVE(fm,tm,(fm+32),(tm+32)); // fall down
						if ((*(fm+64) >= PLAYER) && (*(fm+64) < PLAYERD+4)) danger=1;
						sndfall=1;
						break;

					case ENEMY1+UP:
					case ENEMY1+RIGHT:
					case ENEMY1+DOWN:
					case ENEMY1+LEFT:
					case ENEMY1+SCAN+UP:
					case ENEMY1+SCAN+RIGHT:
					case ENEMY1+SCAN+DOWN:
					case ENEMY1+SCAN+LEFT:
						Explode(x,y+1);
						break;

					case ENEMY2+UP:
					case ENEMY2+RIGHT:
					case ENEMY2+DOWN:
					case ENEMY2+LEFT:
					case ENEMY2+SCAN+UP:
					case ENEMY2+SCAN+RIGHT:
					case ENEMY2+SCAN+DOWN:
					case ENEMY2+SCAN+LEFT:
						Explode(x,y+1);
						break;

					case STONE:
					case DIAMOND:
					case BRICK:
					{
						if ((*(fm-1) == EMPTY) && (*(fm+31) == EMPTY))
						{ // fall down left
							MOVE(fm,tm,(fm-1),(tm-1)); sndfall=1; break;
						}
						if ((*(fm+1) == EMPTY) && (*(fm+33) == EMPTY))
						{ // fall down right
							MOVE(fm,tm,(fm+1),(tm+1)); sndfall=1; break;
						}
						break;
					}

				} // switch *(f+32)
				break;
			} // case DIAMOND,STONE

			case ENEMY1+UP:
			case ENEMY1+RIGHT:
			case ENEMY1+DOWN:
			case ENEMY1+LEFT:
			case ENEMY1+SCAN+UP:
			case ENEMY1+SCAN+RIGHT:
			case ENEMY1+SCAN+DOWN:
			case ENEMY1+SCAN+LEFT:
			case ENEMY2+UP:
			case ENEMY2+RIGHT:
			case ENEMY2+DOWN:
			case ENEMY2+LEFT:
			case ENEMY2+SCAN+UP:
			case ENEMY2+SCAN+RIGHT:
			case ENEMY2+SCAN+DOWN:
			case ENEMY2+SCAN+LEFT:
			if (((*fm) & SCAN) == scan)
			{ // move enemy
				long icur, ileft, iright;
				int left, right;
				long cur = (*fm) & 3;

				switch (cur)
				{
					case UP:    icur = -32; ileft = -1;  iright = +1;  left = LEFT;  right = RIGHT; break;
					case RIGHT: icur = +1;  ileft = -32; iright = +32; left = UP;    right = DOWN;  break;
					case DOWN:  icur = +32; ileft = +1;  iright = -1;  left = RIGHT; right = LEFT;  break;
					case LEFT:  icur = -1;  ileft = +32; iright = -32; left = DOWN;  right = UP;    break;
				}

				if (rand() & 1)
				{
					if (EnemyMove(fm, tm, left, ileft)); // turn left?
					else if (EnemyMove(fm, tm, cur, icur)); // current direction?
					else PUT(*fm,tm, ((*fm & 0xF8) | (scan^SCAN) | right)); // turn right
				} else {
					if (EnemyMove(fm, tm, right, iright)); // turn right?
					else if (EnemyMove(fm, tm, cur, icur)); // current direction?
					else PUT(*fm,tm, ((*fm & 0xF8) | (scan^SCAN) | left)); // turn left
				}

				break;
			}

		} // switch (*fm)
	} // for

	scan ^= SCAN;
	//if (sndfall && alive) SndFallBrick();
}

//////////////////////////////////////////////////////////////////////////////
// EnemyMove                                                                //
//////////////////////////////////////////////////////////////////////////////
int EnemyMove(UCHAR *fm, UCHAR *tm, int dir, long idir) // move an enemy
{
	switch (*(fm+idir))
	{
		case PLAYER:
		case PLAYERD+UP:
		case PLAYERD+RIGHT:
		case PLAYERD+DOWN:
		case PLAYERD+LEFT:
			Explode(px,py);
			alive=0;
			return 1;

		case EMPTY:
			*fm = (*fm & 0xF8) | (scan^SCAN) | dir;
			MOVE(fm,tm,(fm+idir),(tm+idir));
			return 1;
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
// ScrollMap                                                                //
//////////////////////////////////////////////////////////////////////////////
void ScrollMap() // scroll background
{
	int sx = px - 10;
	int sy = py - 9;
	if (sx < 0) sx = 0; if (sx > 32-20) sx = 32-20;
	if (sy < 0) sy = 0; if (sy > 32-18) sy = 32-18;
	move_bkg(sx<<3, sy<<3);
}

//////////////////////////////////////////////////////////////////////////////
// CanMove                                                                  //
//////////////////////////////////////////////////////////////////////////////
int CanMove(char a, char b) // check if tile is blocking
{
	switch (a)
	{
		case DIAMOND:
		case EMPTY:
		case NORMAL:
			return 1;
		case STONE:
			return (b == EMPTY);
		case EXIT:
			return (diamonds == 0);
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
// MovePlayer                                                               //
//////////////////////////////////////////////////////////////////////////////
int MovePlayer() // player input & movement
{
	int x2,x3,y2,canmove=0;
	static UBYTE lastjoy;
	UBYTE joy = joypad();

	if ((joy & J_START) && (!(lastjoy & J_START)))
	{
		if (!alive)
		{ // restart level
			return 0;
		}
		else while (1)
		{ // explode / pause
			joy = joypad();

			if (joy & J_SELECT)
			{ // explode
				Explode(px,py);
				break;
			}

			if (!(joy & J_START))
			{ // pause
				//SndDiamond();
				delay(60);
				//SndDiamond();
				delay(60);
				while (!(joypad() & J_START))
				{
					wait_vbl_done(); LCDC_REG ^= 128; delay(100);
				}
				wait_vbl_done(); LCDC_REG |= 128;
				//SndDiamond();
				delay(60);
				//SndDiamond();
				delay(60);
				break;
			}
		}
	}
	lastjoy = joy;
	if (!alive) return 1; // continue without moving player if not alive

	if (joy & J_UP) if (CanMove(fastmap[py-1][px], fastmap[py][px]))
	{
		x2=px; x3=px; y2=py-1; canmove |= 1; fastmap[py][px] = PLAYERD + UP;
	}
	if (joy & J_DOWN) if (CanMove(fastmap[py+1][px], fastmap[py][px]))
	{
		x2=px; x3=px; y2=py+1; canmove |= 1; fastmap[py][px] = PLAYERD + DOWN;
	}
	if (joy & J_LEFT) if (CanMove(fastmap[py][px-1], fastmap[py][px-2]))
	{
		x2=px-1; x3=px-2; y2=py; canmove |= 1; fastmap[py][px] = PLAYERD + LEFT;
	}
	if (joy & J_RIGHT) if (CanMove(fastmap[py][px+1], fastmap[py][px+2]))
	{
		x2=px+1; x3=px+2; y2=py; canmove |= 1; fastmap[py][px] = PLAYERD + RIGHT;
	}

	if (canmove)
	{
		switch (fastmap[y2][x2])
		{
			case DIAMOND:
				//SndDiamond();
				if (diamonds) if (!--diamonds)
				{
					int n;
					for (n=0; n<10; n++)
					{
						delay(60);
						//SndDiamond();
						wait_vbl_done(); LCDC_REG ^= 128;
					}
				}
				break;

			case STONE:
				PUT(fastmap[y2][x3], &(*tilemap)[y2][x3], STONE);
				//SndMoveStone();
				break;

			case EXIT:
				//if (diamonds == 0) SndWon();
				return 0;
				break;

			case NORMAL:
				//SndStep();
				break;

			default:
				break;
		}
		MOVE(&fastmap[py][px], &(*tilemap)[py][px], &fastmap[y2][x2], &(*tilemap)[y2][x2]);
		py=y2; px=x2; danger=0;
	}
	else
	{
		PUT(fastmap[py][px], &(*tilemap)[py][px], PLAYER);
	}

	if (danger) Explode(px,py); // should have walked away ;-(

	return 1;
}

//////////////////////////////////////////////////////////////////////////////
// Init                                                                     //
//////////////////////////////////////////////////////////////////////////////
void Init()
{
	LCDC_REG &= 0xEF;
	set_bkg_data(0, 32, tiles);
	set_bkg_palette(0, 8, palettes);
	VBK_REG = 1; set_bkg_tiles(0,0, 32,32, mapPLN1);
	VBK_REG = 0; set_bkg_tiles(0,0, 32,32, mapPLN0);
	memcpy(fastmap, mapPLN0, (long)32*32);
	InitSound();
	DISPLAY_ON;
}

//////////////////////////////////////////////////////////////////////////////
// Title                                                                    //
//////////////////////////////////////////////////////////////////////////////
void Title()
{
	DISPLAY_OFF;
	LCDC_REG |= 0x10;
	VBK_REG = 1; set_data((void*)0x8000, titleBLK1, 112*16L);
	VBK_REG = 0; set_data((void*)0x8000, titleBLK0, 256*16L);
	VBK_REG = 1; set_bkg_tiles(0,0,20,18, titlemapPLN1);
	VBK_REG = 0; set_bkg_tiles(0,0,20,18, titlemapPLN0);
	set_bkg_palette(0, 8, paltitle);
	DISPLAY_ON;
	while ((joypad() & J_START) == 0);
	while (joypad() & J_START);
	DISPLAY_OFF;
}

//////////////////////////////////////////////////////////////////////////////
// ClearScreen                                                              //
//////////////////////////////////////////////////////////////////////////////
void ClearScreen()
{
	int i;
	for (i=0; i<32; i++)
	{
		int x, empty[20];
		for (x=0; x<20; x++) empty[x] = 0;
		VBK_REG = 1; set_bkg_tiles(0,i,20,1, (void*)empty);
		VBK_REG = 0; set_bkg_tiles(0,i,20,1, (void*)empty);
	}
}

//////////////////////////////////////////////////////////////////////////////
// main                                                                     //
//////////////////////////////////////////////////////////////////////////////
void main()
{
	while (1)
	{
		Title();

		danger=0; alive=1;
		px=1; py=1; ScrollMap();
		diamonds=64;
		Init();

		while (!(joypad() & (J_UP | J_DOWN | J_LEFT | J_RIGHT)))
		{
			PUT(fastmap[py][px], &(*tilemap)[py][px], EMPTY); delay(100);
			PUT(fastmap[py][px], &(*tilemap)[py][px], PLAYER); delay(100);
		}

		while (MovePlayer())
		{
			ScrollMap();
			ScanMap();
			wait_vbl_done();
			UpdateRumble();
		}
	}
}
